---
title: 'ARIA: document role'
slug: Web/Accessibility/ARIA/Roles/Document_Role
tags:
  - ARIA
  - ARIA Role
  - Document
  - Reference
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>
<p><span class="seoSummary">Generally used in complex composite <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/widget_Role">widgets</a> or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Application_Role">applications</a>, the <code>document</code> role can inform assistive technologies to switch context to a reading mode: The <code>document</code> role tells assistive technologies with reading or browse modes to use the document mode to read the content contained within this element.</span></p>

<pre class="brush: html">&lt;div role="dialog"&gt;
 ...
 &lt;div id="InfoText" role="document" tabindex="0"&gt;
  &lt;p&gt;Some informational text goes here.&lt;/p&gt;
 &lt;/div&gt;
 ...
 &lt;button&gt;Close&lt;/button&gt;
&lt;/div&gt;
</pre>

<p>This example shows a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/diialog_Role">dialog</a> widget with some controls and a section with some informational text that the assistive technology user can read when tabbing to it.</p>

<h2 id="Description">Description</h2>

<p>By default, web pages are treated as documents; assistive technologies (AT) enter browse or read mode when entering a new web page. This mode can be altered through various roles, including the widget and application roles. The <code>document</code> role brings the AT back into browse or read mode. </p>

<p>Generally placed within an application role or other interactive widget role, the <code>document</code> role is used to indicate a section of a complex composit widget that an assistive technology user should read using its browse or virtual reading mode, if available.</p>

<p>Because ATs with reading mode default to that mode for all elements except for those with a widget or application role set, document role is only useful for focusable elements within a widget or application that should be read as static rich text. Adding <code>role="document"</code> and <code>tabindex="0"</code> to the element containing the text within a widget enables the screen reader user to press the Tab key to place focus on the document element and read the text with the screen reader's reading cursor.</p>

<p>Assistive technologies should switch context back to document mode, possibly intercepting from controls rewired for the parent's dynamic context, re-enabling the standard input events, such as Up or Down arrow keyboard events, to control the reading cursor.</p>

<p>In contrast to the <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Article_Role">article</a></code> role, the <code>document</code> role does not have any relation to other elements with a document role, it merely has a relationship to the containing composit widget. An article can have associated articles.</p>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<dl>
 <dt><code>aria-expanded</code></dt>
 <dd>Include with a value of <code>true</code> or <code>false</code> if the document element is collapsible, to indicate if the document is currently expanded or collapsed. Other values include the default <code>undefined</code> which means the document is not collapsible.</dd>
</dl>

<dl>
 <dt>tabindex="0"</dt>
 <dd>Used to make it focusable so the assistive technology user can tab to it and start reading right away.</dd>
</dl>


<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>The element should be made focusable by setting the <code>tabindex="0"</code> attribute / value pair on it. This way, the user can tab to it, reading mode is invoked automatically, and the content can be read right away.</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>None, except as required by any attributes. For example, if the <code>document</code> is collapsible, then the state and the value of <code>aria-expanded</code> must be maintained.</p>

<h2 id="Examples">Examples</h2>

<p>An example is Gmail and the single conversation view. GMail is a web application. When in GMail, most user agent interactions are usurped by the application. However, when the Keyboard focus is set on the starting heading on a single conversation that contains the subject of the conversation, the screen reader user can use the reading mode commands to read through the messages, expand or collapse them, and manipulate them. Once focus returns to the message list either by activating the Back button or pressing an asociated keystroke, direct application interaction mode is invoked again, and the user can move to a different conversation in the list with the <kbd>arrow</kbd> keys.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Always make sure an item with the document role is focusable, by setting the <code>tabindex</code> attribute with a value of 0. That will also include it in the tab order.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>The document role is an easy way to indirectly control assistive technology behavior by unambiguously stating that this is content the user should read with standard screen reader commands.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#document","document")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>


<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/widget_Role">ARIA:widget role</a> </li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Application_Role">ARIA: application role</a></li>
</ul>
